function dy = centered_diff(y);

%compute first derivative of function
dy = zeros(1,length(y));

%Define end-points of derivative (using 1/2 of centered diff formula)
dy(1) = y(2)-y(1);
dy(end) = y(end)-y(end-1);

for i = 2:length(y)-1
    
    %First derivative computed by central diff
    dy(i) = (y(i+1)-y(i-1))/2;

end

%Compute first derivative w/o for-loop
    
%Define new arrays that are bitshifted forwards and backwards
y_back = [0,0,y];
y_for = [y,0,0];
    
%First derivative computed by central diff
dy_temp = 0.5*(y_for-y_back);

%Combine two endpoints and the central part of the bitshift equation into a single vector
dy_mat = [dy(1),dy_temp(3:end-2),dy(end)];

%dy = dy_mat;
end