function y_xx = centered_diff_interp(x,y,xx);

%compute first derivative of function
first_deriv = centered_diff(y);

%USE GRADIENT IF YOU DON'T HAVE "centered_diff.m" function
%first_deriv = gradient(y);

y_xx = [];

for i = 1:length(xx)
    
    %find nearest neighbour
    [val,index] = min(abs(xx(i)-x));

    %xx(i)
    %round((xx(i)-x(index)),18)
    
    pos_flag    = sign(round(xx(i)-x(index),18));
    %if pos_flag = -1 then the nearest neighbour x(index) > xx(i)
    %round to 18 decimal places to remove any numerical error from MATLAB

    %if "in_front" of nearest neighbour
    if pos_flag == 1
        index_ub = index+1;
        index_lb = index;
        avg_slope   = 0.5 * (first_deriv(index_lb)+first_deriv(index_ub));
        y_xx(i)     = y(index_lb) + avg_slope * (xx(i)-x(index_lb)) / (x(index_ub)-x(index_lb));
    end
    
    %if "behind" nearest neighbour
    if pos_flag == -1
        index_ub = index;
        index_lb = index-1;
        avg_slope   = 0.5 * (first_deriv(index_lb)+first_deriv(index_ub));
        y_xx(i)     = y(index_lb) + avg_slope * (xx(i)-x(index_lb)) / (x(index_ub)-x(index_lb));
    end
    
    %if at intersection point
    if pos_flag == 0
        y_xx(i) = y(index);
    end


end