function [total_l,total_r] = tut_integral(y,x)

%initialize totals
total_l = 0;
total_r = 0;

for i = 1:length(y)-1
    
    %Define width of rectangle via (x2 - x1) and multiply by either
    %lefthand or righthand "y" point
    total_l = total_l + (x(i+1)-x(i))*y(i);
    total_r = total_r + (x(i+1)-x(i))*y(i+1);
end

%define bitshifted arrays (just like in derivative case)
x_down    = [x(1),x];
x_up  = [x,x(end)];
dx      = x_up - x_down;

%If you write this out using row / column vectors you get 
%[(x(2) - x(1))*y(1) + (x(3) - x(2))*y(2) + ... etc]
mat_total_l = dx * [y,0]';
mat_total_r = dx * [0,y]';

end